// math functions

gmexport double ds_bin_val_add(double dest_id, double id, double val) {
	unsigned long xx,yy,zz;
	uint32_t value;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin,xx,yy,zz)+value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_subtract(double dest_id, double id, double val) {
	unsigned long xx,yy,zz;
	uint32_t value;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin,xx,yy,zz)-value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_invsubtract(double dest_id, double id, double val) {
	unsigned long xx,yy,zz;
	uint32_t value;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,value-bin_get(bin,xx,yy,zz));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_multiply(double dest_id, double id, double val) {
	unsigned long xx,yy,zz;
	uint32_t value;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin,xx,yy,zz)*value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_divide(double dest_id, double id, double val) {
	unsigned long xx,yy,zz;
	uint32_t value;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,bin_get(bin,xx,yy,zz)/value);
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_invdivide(double dest_id, double id, double val) {
	unsigned long xx,yy,zz;
	uint32_t value;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,value/bin_get(bin,xx,yy,zz));
			}
		}
	}
	return 1;
}

// expression functions

gmexport double ds_bin_val_equal(double dest_id, double id, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	uint32_t value,truevalue,falsevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin,xx,yy,zz)==value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_notequal(double dest_id, double id, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	uint32_t value,truevalue,falsevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin,xx,yy,zz)!=value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_greaterthan(double dest_id, double id, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	uint32_t value,truevalue,falsevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin,xx,yy,zz)>value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_greaterthanorequal(double dest_id, double id, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	uint32_t value,truevalue,falsevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin,xx,yy,zz)>=value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_lessthan(double dest_id, double id, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	uint32_t value,truevalue,falsevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin,xx,yy,zz)<value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_lessthanorequal(double dest_id, double id, double val, double trueval, double falseval) {
	unsigned long xx,yy,zz;
	uint32_t value,truevalue,falsevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	truevalue = (uint32_t) trueval;
	falsevalue = (uint32_t) falseval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				bin_set(dest,xx,yy,zz,((bin_get(bin,xx,yy,zz)<=value)?(truevalue):(falsevalue)));
			}
		}
	}
	return 1;
}

// replace-expression functions

gmexport double ds_bin_val_replaceequal(double dest_id, double id, double val, double replaceval) {
	unsigned long xx,yy,zz;
	uint32_t value,replacevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin,xx,yy,zz)==value) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_replacenotequal(double dest_id, double id, double val, double replaceval) {
	unsigned long xx,yy,zz;
	uint32_t value,replacevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin,xx,yy,zz)!=value) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_replacegreaterthan(double dest_id, double id, double val, double replaceval) {
	unsigned long xx,yy,zz;
	uint32_t value,replacevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin,xx,yy,zz)>value) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_replacegreaterthanorequal(double dest_id, double id, double val, double replaceval) {
	unsigned long xx,yy,zz;
	uint32_t value,replacevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin,xx,yy,zz)>=value) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_replacelessthan(double dest_id, double id, double val, double replaceval) {
	unsigned long xx,yy,zz;
	uint32_t value,replacevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin,xx,yy,zz)<value) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

gmexport double ds_bin_val_replacelessthanorequal(double dest_id, double id, double val, double replaceval) {
	unsigned long xx,yy,zz;
	uint32_t value,replacevalue;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	replacevalue = (uint32_t) replaceval;
	for(zz=0;zz<dest->z;++zz) {
		for(yy=0;yy<dest->y;++yy) {
			for(xx=0;xx<dest->x;++xx) {
				if(bin_get(bin,xx,yy,zz)<=value) {
					bin_set(dest,xx,yy,zz,replacevalue);
				}
			}
		}
	}
	return 1;
}

// boolean functions (not useful here)

// bitwise functions

gmexport double ds_bin_val_bitwise_and(double dest_id, double id, double val) {
	unsigned long i;
	uint32_t value,fill;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	fill = 0;
	for(i=0;i<dest->entriesperword;++i) {
		fill |= value<<(i*dest->bits);
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = bin->data[i] & fill;
	}
	return 1;
}

gmexport double ds_bin_val_bitwise_or(double dest_id, double id, double val) {
	unsigned long i;
	uint32_t value,fill;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	fill = 0;
	for(i=0;i<dest->entriesperword;++i) {
		fill |= value<<(i*dest->bits);
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = bin->data[i] | fill;
	}
	return 1;
}

gmexport double ds_bin_val_bitwise_xor(double dest_id, double id, double val) {
	unsigned long i;
	uint32_t value,fill;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	fill = 0;
	for(i=0;i<dest->entriesperword;++i) {
		fill |= value<<(i*dest->bits);
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = bin->data[i] ^ fill;
	}
	return 1;
}

gmexport double ds_bin_val_bitwise_nand(double dest_id, double id, double val) {
	unsigned long i;
	uint32_t value,fill;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	fill = 0;
	for(i=0;i<dest->entriesperword;++i) {
		fill |= value<<(i*dest->bits);
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( bin->data[i] & fill );
	}
	return 1;
}

gmexport double ds_bin_val_bitwise_nor(double dest_id, double id, double val) {
	unsigned long i;
	uint32_t value,fill;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	fill = 0;
	for(i=0;i<dest->entriesperword;++i) {
		fill |= value<<(i*dest->bits);
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( bin->data[i] | fill );
	}
	return 1;
}

gmexport double ds_bin_val_bitwise_nxor(double dest_id, double id, double val) {
	unsigned long i;
	uint32_t value,fill;
	ds_bin *dest,*bin;
	if((dest=search_bin((unsigned long) dest_id))==NULL) return -1;
	if((bin=search_bin((unsigned long) id))==NULL) return -1;
	if(!(dest->bits==bin->bits && dest->x==bin->x && dest->y==bin->y && dest->z==bin->z )) {
		return 0;
	}
	value = (uint32_t) val;
	fill = 0;
	for(i=0;i<dest->entriesperword;++i) {
		fill |= value<<(i*dest->bits);
	}
	for(i=0;i<dest->count;++i) {
		dest->data[i] = ~( bin->data[i] ^ fill );
	}
	return 1;
}

